<?php

/**
 * datos_titular actions.
 *
 * @package    cobro_coactivo
 * @subpackage datos_titular
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class datos_titularActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_DATOS_TITULAR',
        'CBR_ACTUALIZA_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'DEPARTAMENTO',
        'MUNICIPIOS'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_ACTUALIZA_TITULO' =>
        array(
            'id_actualiza_titulo' => 'CBR_DATOS_TITULAR'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_ACTUALIZA_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_ACTUALIZA_TITULO'
        ),
        'DEPARTAMENTO' =>
        array(
            'id_depto' => 'CBR_DATOS_TITULAR'
        ),
        'MUNICIPIOS' =>
        array(
            'codmun' => 'CBR_DATOS_TITULAR'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_DATOS_TITULAR' =>
        array(
            'id_datos_titular' => 'id_datos_titular',
            'id_actualiza_titulo' => 'id_actualiza_titulo',
            'telefono' => 'telefono',
            'direccion' => 'direccion',
            'id_depto' => 'id_depto',
            'codmun' => 'codmun'
        ),
        'CBR_ACTUALIZA_TITULO' =>
        array(
            'cod_titulo' => 'cod_titulo',
            'nombre_razon' => 'nombre_razon',
            'nitocc' => 'nitocc',
            'email' => 'email'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'DEPARTAMENTO' =>
        array(
            'descripcion' => 'departamento'
        ),
        'MUNICIPIOS' =>
        array(
            'municipio' => 'municipio'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'direccion'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_DATOS_TITULAR' =>
        array(
            'id_datos_titular,a' => array('!=' => array(-1)),
            'id_datos_titular,b' => array('=' => array('id_datos_titular')),
            'id_actualiza_titulo' => array('=' => array('id_actualiza_titulo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_datos_titular'; //identificador de la tabla
    protected $id_names = array('id_datos_titular'); //llave primaria
    protected $field_names = array('id_actualiza_titulo', 'telefono', 'direccion', 'id_depto', 'codmun'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_DATOS_TITULAR'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_datos_titular'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
